
structure ipl = struct val thy = theory "ipl" end ;
use_legacy_bindings ipl.thy ;

AddSEs [ljss.extI, ljne.ilI, ljne.irI] ;
AddSIs [ljne.axiom] ; Addsimps [ljne.axiom] ;

fun psc_inst th = rewrite_rule [mk_eq pscmap_def]
  (read_instantiate [("psc", "(?ps, ?c)")] th) ;
val ljss_extI2 = ljss.extI ;
val ljss_extIpc = psc_inst ljss.extI ;
val ljss_extIpcp = rewrite_rule [extend_def] ljss_extIpc ;

val _ = qed_goal "ljss_iextrs" ipl.thy "ljss = iextrs ljne"
  (fn _ => [ Safe_tac, (etac ljss.elims 1), (etac iextrs_E' 2),
    Asm_simp_tac 1, Fast_tac 1, 
    (dtac ljss.extI 1), (asm_simp_tac HOL_ss 1) ]) ; 

val _ = bind_thm ("ljss_def", ljss_iextrs RS eq_reflection) ;

val _ = qed_goal "ljne_eq" ipl.thy "ljne = idrls Un ljil Un ljir" 
  (fn _ => [ (safe_tac (ces [ljne.elims, idrls.elims])) ]) ;

val _ = qed_goal "ljne_idrls" ipl.thy "ljne >= idrls" 
  (fn _ => [ (safe_tac (ces [idrls.elims])) ]) ;
val ljne_idrls' = mk_mono' ljne_idrls ;
AddSEs [ljne_idrls'] ; 

val _ = bind_thm ("extrs_ir_ljne",
  mk_mono ljne.irI RSN (2, extrs_single_sub)) ;
val _ = bind_thm ("extrs_il_ljne", 
  mk_mono ljne.ilI RSN (2, extrs_single_sub)) ;

(** characteristics of rules used later **)

(* NOT TRUE 
val () = qed_goal_spec_mp "ljil_no_antec'" ipl.thy 
  "UV = (U |- V) --> (ps, UV) : ljil --> ~ A :# V"
  (fn _ => [ (Clarify_tac 1), (etac ljil.elims 1), Auto_tac ]) ;

val ljil_no_antec = refl RS ljil_no_antec' ;
*)

val () = qed_goal_spec_mp "ljir_no_antec'" ipl.thy 
  "UV = (U |- V) --> (ps, UV) : ljir --> ~ A :# U"
  (fn _ => [ (Clarify_tac 1), (etac ljir.elims 1), Auto_tac ]) ;

val ljir_no_antec = refl RS ljir_no_antec' ;

val () = qed_goal_spec_mp "lj_concl_ilc_sf" ipl.thy 
  "(ps, c) : ljil --> (EX A C. c = ({#A#} |- {#C#}) & \
    \ (ALL p : set ps. (ALL y: set_of (antec p). y = A | (y, A) : ipsubfml)))" 
  (fn _ => [ (rtac impI 1), (etac ljil.elims 1), Auto_tac,
    (TRYALL (etac notE THEN' resolve_tac ipsfIs)) ]) ;

val () = qed_goal_spec_mp "lj_concl_irc_sf" ipl.thy 
  "(ps, c) : ljir --> (EX A. c = ({#} |- {#A#}) & \
    \ (ALL p : set ps. (ALL y: set_of (ms_of_seq p). (y, A) : ipsubfml)))" 
  (fn _ => [ (rtac impI 1), (etac ljir.elims 1), Auto_tac,
    (ALLGOALS (resolve_tac ipsfIs)) ]) ;

val ex_match2 = tacthm (etac ex_match 2) ex_match ;

val lj_concl_ilrc as [lj_concl_ilc, lj_concl_irc] =
  [lj_concl_irc_sf, lj_concl_ilc_sf] RL
    (map (tacthm (etac conjunct1 2)) [ex_match2, ex_match]) ;
val lj_concl_ilrcEs = lj_concl_ilrc RL [exE] ;

val () = qed_goal_spec_mp "lj_concl_ss1r" ipl.thy 
  "(ps, c) : ljir --> seq_size c = 1" 
  (fn _ => [ (rtac impI 1), (dtac lj_concl_irc 1), Auto_tac]) ;

val () = qed_goal_spec_mp "lj_concl_ss1l" ipl.thy 
  "(ps, c) : ljil --> seq_size c = 2" 
  (fn _ => [ (rtac impI 1), (dtac lj_concl_ilc 1), Auto_tac]) ;

(* don't get this for left rules *)
val _ = ListPair.app bind_thm (["ljir_scrls'"],
  [lj_concl_ss1r] RL [scrls.intros]) ;

(* don't get this for left rules
val _ = qed_goal_spec_mp "ljil_scrls" ipl.thy
  "psc : ljil --> psc : scrls" 
  (fn _ => [ (case_tac "psc" 1), Safe_tac,
    rtac scrls.I 1, (etac lj_concl_ss1l 1) ]) ;
*)

val _ = qed_goal_spec_mp "ljir_scrls" ipl.thy
  "psc : ljir --> psc : scrls" 
  (fn _ => [ (case_tac "psc" 1), Safe_tac,
    rtac scrls.I 1, (etac lj_concl_ss1r 1) ]) ;

(*
val () = qed_goal "lj_iscrls" ipl.thy "ljne <= iscrls"
  (fn _ => [ (safe_tac (ces [ljne.elims])),
    (TRYALL (dresolve_tac lj_concl_ilrc)),
    Auto_tac, (TRYALL (rtac iscrls_s1I)), Auto_tac ]) ;

val _ = bind_thm ("ljil_atomic", 
  lj_concl_ss1l RS order_eq_refl RS (seq_atomic_def RS iffD2)) ;
*)

val _ = bind_thm ("ljir_atomic", 
  lj_concl_ss1r RS order_eq_refl RS (seq_atomic_def RS iffD2)) ;

(* doesn't hold with singletons on the right, eg
  A1 |- A1 /\ A2
  --------------
A1 /\ A2 |- A1 /\ A2
  
val () = qed_goalw "lj_unique_concl" ipl.thy [unique_concl_def]
  "unique_concl ljne"
  (fn _ => [ (safe_tac (ces [ljne.elims])),
    (TRYALL (dresolve_tac lj_concl_ilrc THEN' Force_tac)),
    (TRYALL (dtac lj_concl_ilc THEN' dtac lj_concl_irc THEN' Force_tac)),
    (auto_tac (ces [ljil.elims, ljir.elims], esimps fc_defs)) ]) ;

val _ = bind_thm ("lj_unique_concl'", 
  meta_std ([unique_concl_def, lj_unique_concl] MRS defD1)) ;
*)

val () = qed_goal_spec_mp "lj_subform" ipl.thy
  "(a, As) : ljne --> ms_of_seq As = {#x#} --> xb : set a --> \
    \ y : set_of (ms_of_seq xb) --> (y, x) : ipsubfml"
  (fn _ => [ (safe_tac (ces [ljne.elims])), 
    (TRYALL (dresolve_tac [lj_concl_ilc_sf, lj_concl_irc_sf])), 
    rewtac Ball_def, (auto_tac (cesimps [union_is_single]))]) ; 

val () = qed_goal_spec_mp "lj_ext_ext" ipl.thy
  "psc : ljss --> pscmap (extend (fl |- 0)) psc : ljss"
  (fn _ => [ (force_tac (cesimps [ljss_iextrs]) 1) ]) ;

val () = qed_goal_spec_mp "lj_ext_ext'" ipl.thy
  "(ps, c) : ljss --> (?eps, extend (fl |- 0) c) : ljss"
  (fn _ => [ (rtac impI 1), (dtac lj_ext_ext 1), 
    (safe_asm_full_simp_tac (simpset()) 1), atac 1]) ;

val () = qed_goal_spec_mp "lj_extI'" ipl.thy
  "(ps, c) : ljne --> ?P"
  (fn _ => [ (rtac impI 1), (dtac ljss.extI 1), 
    (safe_asm_full_simp_tac (simpset()) 1), atac 1]) ;

val () = qed_goal_spec_mp "lj_extI2" ipl.thy
  "(ps, X |- Y) : ljne --> ?P"
  (fn _ => [ (rtac impI 1), (dtac ljss.extI 1), 
    (safe_asm_full_simp_tac (simpset()) 1), atac 1]) ;

(* develop explicit rules *)
val ljss_intrs as [ljss_axiom', ljil_ljss', ljir_ljss'] =
  (ljne.intros RL [ljss.extI]) ; 
val ljss_axiom = (simplify (simpset ())) ljss_axiom' ;
fun mk_rule_lj intr = map (simplify (simpset ())) ([intr] RL ljss_intrs) ;

val () = qed_goal_spec_mp "lj_simpI" ipl.thy "psc : ljne --> psc : ljss"
  (fn _ => [ (rtac impI 1), 
    (dres_inst_tac [("fl", "0")] ljss.extI 1), 
    (Full_simp_tac 1)]) ;

(* rules have distinct conclusions, not true for additive rules 
val () = qed_goal_spec_mp "lj_dist" ipl.thy 
  "(ps, c) : ljne --> (qs, c) : ljne --> ps = qs"
  (fn _ => [Safe_tac, 
    (REPEAT_SOME (eresolve_tac [ljne.elims, ljir.elims, ljil.elims])),
    (ALLGOALS Clarify_tac),
    (TRYALL (eresolve_tac (conjs single_not_empty RL [notE]))),
    (TRYALL (dtac (single_eq_single RS iffD1))),
    (TRYALL (eresolve_tac fcEs)), (ALLGOALS Asm_simp_tac)]) ;
*)

(* same formulae have intro rules on right as on left *)
(*
val () = qed_goal_spec_mp "lj_same" ipl.thy 
  "(ALL psl. (psl, {#A#} |- 0) ~: ljil) = \
    \ (ALL psr. (psr, 0 |- {#A#}) ~: ljir)"
  (fn _ => [ (safe_tac (ces [ljil.elims, ljir.elims] addSDs
      [single_eq_single RS iffD1])),
    rewtac Zero_multiset_def, 
    (ALLGOALS (EVERY'
      [etac allE, etac notE, resolve_tac (ljir.intros @ ljil.intros)])) ]) ;
*)

val _ = qed_goal_spec_mp "lj_not_Box" ipl.thy
  "(ab, bb) : ljil Un ljir --> bb <= (mset_map Box X |- {#Box B#}) --> R"
  (fn _ => [ (safe_tac (ces [ljil.elims, ljir.elims])),
    (ALLGOALS (clarsimp_tac (ces (mset_mapE :: fc_distEs),
      esimps [single_le, in_single_count]))) ]) ;

(* arbitrary singletons on the right for lj
val _ = qed_goal_spec_mp "lj_no_Box_succ" ipl.thy
  "(ab, (a |- s)) : ljil Un ljir --> Box x :# s --> R"
  (fn _ => [ (safe_tac (ces [ljil.elims, ljir.elims])),
    (ALLGOALS (clarsimp_tac (ces (mset_mapE :: fc_distEs),
      esimps [single_le, in_single_count]))) ]) ;
*)

val _ = qed_goal_spec_mp "lj_no_Box_ant" ipl.thy
  "(ab, (a |- s)) : ljil Un ljir --> Box x :# a --> R"
  (fn _ => [ (safe_tac (ces [ljil.elims, ljir.elims])),
    (ALLGOALS (clarsimp_tac (ces (mset_mapE :: fc_distEs),
      esimps [single_le, in_single_count]))) ]) ;

val _ = qed_goal_spec_mp "lj_not_Box'" ipl.thy
  "(ab, bb) : ljil Un ljir --> \
    \ bb <= (mset_map Box X |- mset_map Box Y) --> R"
  (fn _ => [ (safe_tac (ces [ljil.elims, ljir.elims])),
    (ALLGOALS (clarsimp_tac (ces (mset_mapE :: fc_distEs),
      esimps [single_le, in_single_count]))) ]) ;

val _ = bind_thm ("mset_map_diff_Box", 
  transfer ipl.thy inj_Box RS mset_map_diff_inj) ;





