
(* intuitionistic propositional logic *)

theory ipl imports seq lksyn (* for the syntax *)
begin

(* listing of rules, logic with single or-right and and-left rules,
      |- A , B     A , B |-    
     ----------   ----------  
      |- A v B     A & B |-    
*)

consts
  (* single-step derivations *)
  ljss :: "formula sequent psc set" 
  ljil :: "formula sequent psc set" 
  ljir :: "formula sequent psc set" 
  ljne :: "formula sequent psc set" 

(* note - we need rules which copy the context, otherwise need
  contraction as an explicit rule, eg, to prove A |- A & A *)

(* system with standard rule, not designed for the proof *)
inductive "ljir"
  intros
    andr : "([{#} |- {#A#}, {#} |- {#B#}], {#} |- {#A && B#}) : ljir"
    orr1 : "([{#} |- {#A#}], {#} |- {#A v B#}) : ljir"
    orr2 : "([{#} |- {#B#}], {#} |- {#A v B#}) : ljir"
    impr : "([{#A#} |- {#B#}], {#} |- {#A -> B#}) : ljir"

inductive "ljil"
  intros
    andl1 : "([{#A#} |- {#C#}], {#A && B#} |- {#C#}) : ljil"
    andl2 : "([{#B#} |- {#C#}], {#A && B#} |- {#C#}) : ljil"
    orl : "([{#A#} |- {#C#}, {#B#} |- {#C#}], {#A v B#} |- {#C#}) : ljil"
    impl : "([{#B#} |- {#C#}, {#A -> B#} |- {#A#}], {#A -> B#} |- {#C#}) : ljil"
    botl : "([], {#F#} |- {#C#}) : ljil"

inductive "ljne"
  intros
    axiom : "([], {#A#} |- {#A#}) : ljne"
    ilI : "psc : ljil ==> psc : ljne"
    irI : "psc : ljir ==> psc : ljne"

inductive "ljss"
  intros
    extI : "psc : ljne ==> pscmap (extend (Sequent fl 0)) psc : ljss"

end

