(* seq.thy
Sequent Calculi under Isabelle/HOL, deep embedding of sequents  
using multisets
*)

theory seq imports seqgen begin 

(* not required, as pm_ge0 < order
instance sequent :: order (seq_refl, seq_trans, seq_antisym, seq_less_le)
*)

instance sequent :: (type) comm_monoid_add 
  apply intro_classes ;
  apply (rule_tac seq_assoc) ;
  apply (rule_tac seq_commute) ;
  apply (rule_tac seq_zero) ;
  done ;

instance sequent :: (type) order 
  apply intro_classes ;
  apply (rule_tac seq_refl) ;
  apply (erule_tac seq_trans) ; apply assumption ;
  apply (erule_tac seq_antisym) ; apply assumption ;
  apply (rule_tac seq_less_le) ;
  done ;

instance sequent :: (type) pm0 
  apply intro_classes ;
  apply (rule_tac seq_plus_minus) ;
  apply (rule_tac seq_minus_minus) ;
  done ;

instance sequent :: (type) pm_ge0 
  apply intro_classes ;
  apply (rule_tac seq_all_ge0) ;
  apply (rule_tac seq_diff_0_le) ;
  apply (erule_tac seq_le_add_diff_eq) ;
  apply (rule_tac seq_less_le) ;
  apply (rule_tac seq_leq_def) ;
  done ;

(* redundant, see pmgl.thy
instance sequent :: (type) lattice ;
*)

end
